--[[
		3D test
		Author: RoboLV
		Date: 2015.07.13
]]
-- Connecting our 3D lib


local l3D = require("3Dlib")
local vec = l3D.vec

function love.load()
    
	tick = 0
	
	--On initialize
	l3D:Initialize()
	--print( love.filesystem.getWorkingDirectory( ) )
	love.filesystem.mount("models.zip", "models")
	l3D:LoadModel("models/teapod.obj")
	l3D:LoadModel("models/cube.obj")
	
	
	test = l3D:newModel()
	test:SetPos( vec(0,-1,3) )
	--test:SetMesh(mmmesh)
	test:SetModel( "models/cube.obj" )
	--test:SetModel( "models/teapod.obj" )
	
	tes2 = l3D:newModel()
	tes2:SetPos( vec(-2,1,5) )
	tes2:SetModel( "models/cube.obj" )
	
	tes3 = l3D:newModel()
	tes3:SetPos( vec(-2,-2,5) )
	tes3:SetModel( "models/cube.obj" )
	
	tes4 = l3D:newModel()
	tes4:SetPos( vec(2,1,5) )
	tes4:SetModel( "models/cube.obj" )
	
	tes4 = l3D:newModel()
	tes4:SetPos( vec(2,-2,5) )
	tes4:SetModel( "models/cube.obj" )
	
	 
end

function love.update(dt)
    
	l3D:Update( dt )
	tick = tick + 0.5*dt
	test:SetPos( vec( math.sin(tick)*1-0.5, math.cos(tick)*1-0.5,4) )
	
	--l3D.cam:SetPos( vec( math.sin(tick)*2-1.5) )
	
end

function love.draw()
	
	love.graphics.setBackgroundColor(0, 0, 0)
	
	--love.graphics.setShader(effect)
	
	l3D:Render()
	
	love.graphics.setColor(255, 255, 255, 255)
    love.graphics.print("Current FPS: "..tostring(love.timer.getFPS( )), 10, 10)
	love.graphics.print("Mesh count in draw: "..tostring(#l3D.mesh), 10, 25)
	love.graphics.print("Vertex count in draw: "..tostring(#l3D.mesh*3), 10, 40)
	love.graphics.print("Models in draw: "..tostring(#l3D.models), 10, 55)
	
	local meshSize = 0
	for _,v in pairs( l3D.models ) do
		meshSize = meshSize + #v.mesh
	end
	love.graphics.print("Mesh count: "..tostring(meshSize), 10, 70)
	love.graphics.print("Vertex count: "..tostring(meshSize*3), 10, 85)
end
